#include	<stdlib.h>
#include	<string.h>
#include	<math.h>

#include	"pictures.h"


#define NoFill   0x100		//prevents zero filling in procedure Create


Image::Image(void)
{
 typ='R';
 sizex=planes=0;
}

Image::Image(Image &I)
{
 int i,s;
 typ='R';
 sizex=planes=0;
 Create(I.SizeX(),I.SizeY(),I.planes);
 if(!Valid()) return;
 s=LineSize();
 for(i=0;i<SizeY();i++) memcpy(LinePtr()[i].v,I.LinePtr()[i].v,s);
};

Image::~Image(void)
{ Erase(); }

int Image::Create(int x, int y, int NewPlanes, int Option)
{
 long ldblk;

 if(LinePtr()!=NULL) Erase();

 planes=NewPlanes & 0xFF;
 sizex=x;

 Realloc((((long)x * planes + 7)/8) ,y);
 if(Option==FILL) Fill(0);

 if(LinePtr()==NULL) return(-1);

 return(0);
}

void Image::Erase(void)
{
 container2D::erase();
 planes=sizex=0;
 return;
}


void Image::SetPixel(int x, int y, long value)
{
void *v;
BYTE i;

if((x>=SizeX())||(x<0)||(y>=SizeY())||(y<0)) return;

switch(planes)
   {
   case 1:i=0x80 >> ( x & 7 );
          x=x>>3;
          if(value) LinePtr()[y].b[x] |=i;
               else LinePtr()[y].b[x] &=~i;
          break;

   case 4:if(x & 1) {
                    x=x>>1;
                    v=&LinePtr()[y].b[x];
                    value=(*(BYTE *)v & 0x0F) | (value << 4);
   		    }
               else {
                    x=x>>1;
                    v=&LinePtr()[y].b[x];
                    value=(*(BYTE *)v & 0xF0) | (value & 0x0F);
                    }
          *(BYTE *)v=(BYTE)value;
          break;

   case 8:LinePtr()[y].b[x]=(BYTE)value;
          break;
   case 24:{
           RGB *rgb;
	   x*=3;
	   rgb=(RGB *)&value;
	   LinePtr()[y].b[x++]=rgb->r;
	   LinePtr()[y].b[x++]=rgb->g;
	   LinePtr()[y].b[x]=rgb->b;
           break;
           }	  
   }

}

long Image::GetPixel(int x, int y)
{
BYTE i;

if(!Valid()) return(0);
if(x>=SizeX()) x=SizeX()-1;
if(y>=SizeY()) y=SizeY()-1;
if(x<0) x=0;
if(y<0) y=0;

switch(planes)
   {
   case 1:i=0x80 >> ( x & 7 );
	  x=x>>3;
	  return((LinePtr()[y].b[x] & i)!=0);
   case 4:if(x & 1) {
		    x=x>>1;
		    return(LinePtr()[y].b[x] >> 4);
		    }
               else {
		    x=x>>1;
		    return(LinePtr()[y].b[x] & 0x0F);
		    }
   case  8:return(LinePtr()[y].b[x]);
   case 16:return(LinePtr()[y].w[x]);
   case 24:{
           RGB rgb;
	   x*=3;
           rgb.r=LinePtr()[y].b[x++];
	   rgb.g=LinePtr()[y].b[x++];
	   rgb.b=LinePtr()[y].b[x];
	   return(*((long*)(&rgb)));	   
           }    
   }
return(0);
}



void Image::FormR(int y, WORD *FData)
{
LinePict Sptr;

if(!Valid()) return;
if(y>=SizeY()) y=SizeY()-1;
if(y<0) y=0;
Sptr.v=LinePtr()[y].v;

switch(planes)
   {
   case 4:for(y=0;y<SizeX();y++)
		{
		*FData=*Sptr.b >> 4;
		FData++;
		if(++y>=SizeX()) break;
		*FData=(WORD) (*Sptr.b & 0xF);
		Sptr.b++;
		FData++;
		}
	  break;
   case 8:for(y=0;y<SizeX();y++) *(FData++)=*(Sptr.b++);
          break;
   }

return;
}


void Image::RfrmB(int y, WORD *FData)
{
LinePict Sptr;

if(!Valid()) return;
if((y>=SizeY())||(y<0)) return;
Sptr=LinePtr()[y];

switch(planes)
   {
   case 4:for(y=0;y<SizeX();y++)
		{
		*Sptr.b=(BYTE)(*FData) << 4;
		FData++;
		if(++y>=SizeX()) break;
		*Sptr.b|=(BYTE)(*FData) & 0xF;
		FData++;
		Sptr.b++;
		}
	  break;
   case 8:for(y=0;y<SizeX();y++) *(Sptr.b++)=*(FData++);
	  break;
   }

return;
}


void convert(Image & obr1,Image & obr2)
{
int x,y;
WORD *ukradek,*uk2;

obr2.Create(obr1.SizeX(),obr1.SizeY(),4);
if(!obr2.Valid()) return;

ukradek=(WORD *)malloc(sizeof(WORD)*obr1.SizeX());

for(y=0;y<obr1.SizeY();y++)
	{
	obr1.FormR(y,ukradek);

	uk2=ukradek;
	for(x=0;x<obr1.SizeX();x++)
		{
//		if(*uk2>0) *uk2=0xFFFF;
//		uk2++;
		}

	obr2.RfrmB(y,ukradek);

	}

free(ukradek);
return;
}

//----------------------------------------------------------------------





void JoinX(unsigned MaxX,BYTE *PtrW,BYTE *ukbity,BYTE element,WORD inc)
{
unsigned i;
BYTE mask;

mask=0x80;
for(i=0;i<MaxX;i++)
	{
	if((*ukbity & mask)!=0) *PtrW |= element;
	PtrW+=inc;
	mask>>=1;
	if(mask==0)
		{
		mask=0x80;
		ukbity++;
		}
	}
return;
}



void Join1Plane(Image &p,unsigned y, char plane,void *ukbity)
{
unsigned blen;
BYTE *pq;
WORD *ukradek;

ukradek=NULL;

blen=(p.SizeX()+7) >> 3;
if ((plane>p.planes)||(y>=p.SizeY())) return;

pq=p.LinePtr()[y].b;

switch(p.planes)
   {
   case  1:memmove(pq,ukbity,blen);
	   break;
   case  8:JoinX(p.SizeX(),pq,(BYTE *)ukbity,1 << (plane-1),1);
	   break;
   case 24:{
	   while(plane>8)
		{
		pq+=1;
		plane-=8;
		};
	   JoinX(p.SizeX(),pq,(BYTE *)ukbity,1 << (plane-1),3);
	   break;
	   };
   case 32:{
	   while(plane>8)
		{
		pq+=1;
		plane-=8;
		};
	   JoinX(p.SizeX(),pq,(BYTE *)ukbity,1 << (plane-1),4);
	   break;
	   };
   default:{			//also 16
	   if(p.planes!=16)
		{
		ukradek=(WORD *)malloc(2*p.SizeX());
		p.FormR(y,ukradek);
		pq=(BYTE *)ukradek;
		};
	   if(plane>8)
		{
		pq+=1;
		plane-=8;
		};
	   JoinX(p.SizeX(),pq,(BYTE *)ukbity,1 << (plane-1),2);

	   if(ukradek!=NULL)
		{
		p.RfrmB(y,ukradek);
		free(ukradek);
		};
	};
    };
}

void JoinPlane(Image & PlaneX,Image & Obr, BYTE PlaneNum)
{
unsigned y,MaxY;

if (((PlaneNum<=0)||(PlaneNum>Obr.planes))||(!PlaneX.Valid())) return;
if (!Obr.Valid())
	{
	Obr.Create(PlaneX.SizeX(),PlaneX.SizeY(),PlaneNum);
	if (!Obr.Valid()) return;
	}

MaxY=(Obr.SizeY()<PlaneX.SizeY())?Obr.SizeY():PlaneX.SizeY();
for(y=0;y<MaxY;y++)		// hlavni radkova smycka
	{
	Join1Plane(Obr,y,PlaneNum,PlaneX.LinePtr()[y].v);
	}
}

//-----------------------------------------------------
void PeelX(unsigned MaxX,BYTE *PtrW,BYTE *ukbity,BYTE element,short inc)
{
unsigned i;
BYTE mask;

mask=0x80;
for(i=0;i<MaxX;i++)
	{
	if(*PtrW & element) *ukbity |= mask;
	PtrW+=inc;
	mask>>=1;
	if(mask==0)
		{
		mask=0x80;
		ukbity++;
		}
	}
return;
}



void Peel1Plane(Image & p, int y,short plane,void *ukbity)
{
unsigned blen;
BYTE *pq;
WORD *ukradek;

ukradek=NULL;

blen=(p.SizeX()+7) >> 3;
memset(ukbity,0,blen);
if ((plane>p.planes)||(y>=p.SizeY())) return;

pq=p.LinePtr()[y].b;

switch(p.planes)
	{
	case 1:memmove(ukbity,pq,blen);
	       break;
	case 8:PeelX(p.SizeX(),pq,(BYTE *)ukbity,1 << (plane-1),1);
	       break;
/*  24:begin
     while plane>8 do
		begin
		inc(longint(pq));
		dec(plane,8);
		end;
     peelX(p.x,pq,ukbity,1 shl (plane-1),3);
     end;
  32:begin
     while plane>8 do
		begin
		inc(longint(pq));
		dec(plane,8);
		end;
     peelX(p.x,pq,ukbity,1 shl (plane-1),4);
     end;*/
	default:		//also 16

	   if(p.planes!=16)
		{
		ukradek=(WORD *)malloc(sizeof(WORD)*p.SizeX());
                p.FormR(y,ukradek);
		pq=(BYTE *)ukradek;
		}
	   if(plane>8)
		{
		pq++;
		plane-=8;
		}
	   PeelX(p.SizeX(),pq,(BYTE *)ukbity,1 << (plane-1),2);

	   if(ukradek!=NULL) free(ukradek);
	}
}

void PeelPlane(Image & obr,Image & PlaneX,int PlaneNum)
{
int y;

PlaneX.Erase();
if((PlaneNum<=0)||(PlaneNum>obr.planes)||(!obr.Valid())) return;
PlaneX.Create(obr.SizeX(),obr.SizeY(),1 | NoFill);

for(y=0;y<obr.SizeY();y++)		// hlavni radkova smycka
       {
       Peel1Plane(obr,y,PlaneNum,PlaneX.LinePtr()[y].v);
       }
}

/* --------- functions for processing a palette ---------- */
char dummy;

void Image::CreatePalette(int type)
{
int i;
char k;

if(planes==0)
   {
   palette.erase();
   return;
   }
palette.Realloc( (1 << planes)*3 );

switch(type)
   {
   case  0:return;
   case  1:k=16;
	   if(planes==4) k=16;
	   for(i=0;i<(1 << planes) ;i++)
		{
		palette.Red(i)=palette.Green(i)=palette.Blue(i)=k*i;
		}
	   break;
   default:return;
   }
}

int TPalette::GrayPalette(void)		//Is this Gray scale palette?
{
unsigned i,j;

 if (Size()==0) return(1);

 for(i=0;i<Colors()-1;i++)
	{
	j=i*255 / (Colors()-1);
	if ((Red(i)!=j) ||
	    (Green(i)!=j) ||
	    (Blue(i)!=j)) return(0);
	}

 return(1);
}




char &TPalette::Red(int i)
{
if(data1D==NULL || 3*i>=size1D) return(dummy);
return(*((char *)data1D + 3*i));
}

char &TPalette::Green(int i)
{
if(data1D==NULL || 3*i>=size1D) return(dummy);
return(*((char *)data1D + 3*i + 1));
}


char &TPalette::Blue(int i)
{
if(data1D==NULL || 3*i>=size1D) return(dummy);
return(*((char *)data1D + 3*i +2));
}



/* ------------ Start of canny edge detection ------------- */
#define Scale1 20

typedef float **PaBox;
typedef float RBox[21];


float fabs( float x )
{
   return ((x > 0) ? x : -x);
}


void getAmem( PaBox *x, WORD rows, WORD cols )
{
   (*x) = (float**) malloc( rows*sizeof(float*));
   for( int i = 0; i < rows; i++ )
        (*x)[i] = (float*) malloc( sizeof( float)*cols );
}

void freeAmem( PaBox *x, WORD rows, WORD cols )
{
   for( int i = 0; i < rows; i++ ) free( (*x)[i] );
}

float gauss( float x, float s )
{
   return( exp(-1.0*(x*x) / (2.0*s*s)) );
}

void New_X_Y_G_Lines( WORD SizeX, int n, PaBox BoxTemp1, PaBox BoxTemp2,
PaBox BoxX,  PaBox BoxY,
 PaBox BoxG, RBox m1 )
{
   int j, k;
   float t3, t4;

   for( j = 0; j <= SizeX+2; j++ ) {
      t3 = t4 = 0;
      for( k = 1; k <= n; k++ ) {
         t4 = t4+m1[k]*(BoxTemp2[n][n+j-k] - BoxTemp2[n][n+j+k]);
         t3 = t3+m1[k]*(BoxTemp1[n-k][n+j] - BoxTemp1[n+k][n+j]);

         BoxY[0][j] = t4;
         BoxX[0][j] = t3;
         BoxG[0][j] = sqrt( (t3*t3) + (t4*t4) );
      }
   }
}

void X_Y_G_Rot( PaBox BoxX, PaBox BoxY, PaBox BoxG )
{
   int k;
   float *StoreX, *StoreY, *StoreG;

   StoreX = BoxX[0];
   StoreY = BoxY[0];
   StoreG = BoxG[0];
   for( k = 0; k <=1; k++ ) {
      BoxX[k] = BoxX[k+1];
      BoxY[k] = BoxY[k+1];
      BoxG[k] = BoxG[k+1];
   }
   BoxX[2] = StoreX;
   BoxY[2] = StoreY;
   BoxG[2] = StoreG;
}

void New_Temp_Line( int n, PaBox BoxTemp1, PaBox BoxTemp2, Image &im_in,
RBox m, int i )
{
   int j, k, l;
   float t3, t4;

   l = 0;
   for( j = -n-1; j <= im_in.SizeX()+n+1; j++ ) {
      t4 = m[0]*im_in.GetPixel( i, j );
      t3 = t4;
      for( k = 1; k < n; k++ ) {
         t3 = t3+m[k]*(im_in.GetPixel(i,j-k) + im_in.GetPixel( i,j+k));
         t4 = t4+m[k]*(im_in.GetPixel(i-k,j)+im_in.GetPixel(i+k,j));
      }
   BoxTemp1[0][l] = t3;
   BoxTemp2[0][l] = t4;
   l++;
   }
}

void Temp_Rot( int n, PaBox BoxTemp1, PaBox BoxTemp2 )
{
   int k;
   float *StoreTemp1, *StoreTemp2;

   StoreTemp1 = BoxTemp1[0];
   StoreTemp2 = BoxTemp2[0];
   for( k = 0; k <= 2*n-1; k++ ) {
      BoxTemp1[k] = BoxTemp1[k+1];
      BoxTemp2[k] = BoxTemp2[k+1];
   }
   BoxTemp1[2*n] = StoreTemp1;
   BoxTemp2[2*n] = StoreTemp2;
}


void X_Y_G_Init( int n, PaBox BoxX, PaBox BoxY, PaBox BoxG, PaBox BoxTemp1,
PaBox BoxTemp2,
 RBox m1, Image &im_in, RBox m )
{
   int i;

   for( i = 0; i <= 2; i++ ) {
      New_X_Y_G_Lines( im_in.SizeX(), n, BoxTemp1, BoxTemp2, BoxX, BoxY, BoxG, m1 );
      X_Y_G_Rot( BoxX, BoxY, BoxG );
      if( i < 2 ) {
         New_Temp_Line( n, BoxTemp1, BoxTemp2, im_in, m, n+1 );
         Temp_Rot( n, BoxTemp1, BoxTemp2 );
      }
   }
}

void Temp_Init( int n, PaBox BoxTemp1, PaBox BoxTemp2, Image &im_in, RBox m
)
{
   int i;

   for( i = -n-1; i <= n-1; i++ ) {
      New_Temp_Line( n, BoxTemp1, BoxTemp2, im_in, m, 1);
      Temp_Rot( n, BoxTemp1, BoxTemp2 );
   }
}

int Edge( PaBox BoxG, float ux, float uy, int j )
{
   float uz, ut, gx, gy;

   ut = ux + uy;
   uz = ux - uy;
   gx = fabs( ux * BoxG[1][j] );
   gy = fabs( uy * BoxG[1][j] );

   if (ux*uy > 0) {

      if( fabs(ux) < fabs(uy) ) {
         if( (gy < fabs( ux*BoxG[2][j+1] - uz*BoxG[1][j+1])) ||
             (gy <= fabs( ux*BoxG[0][j-1] - uz*BoxG[1][j-1]) )) return 1;
      }
      else
      {
         if( (gx < fabs( uy*BoxG[2][j+1] + uz*BoxG[2][j] )) ||
             (gx <= fabs( uy*BoxG[0][j-1] + uz*BoxG[0][j] ))) return 1;
      }
   }
   else
   {
      if( fabs( ux ) < fabs( uy ) ) {
         if( ( gy < fabs( ux*BoxG[2][j-1] - ut*BoxG[1][j-1] ) ) ||
             (gy<=fabs(ux*BoxG[0][j+1] - ut*BoxG[1][j+1]))) return 1;
      }
      else
      {
         if( (gx< fabs(uy*BoxG[2][j-1] - ut*BoxG[2][j])) ||
            (gx<= fabs(uy*BoxG[0][j+1] - ut*BoxG[0][j]))) return 1;
      }
   }

   return 0;
}

void Main_Cycle( int n, PaBox BoxX, PaBox BoxY, PaBox BoxG, PaBox BoxTemp1,
PaBox BoxTemp2,
 RBox m, RBox m1, Image &im_in, Image &im_out, Image &im_dir, float scale )
{
   int i,j,t;
   float ux,uy;

   for( i = 0; i <= im_in.SizeX(); i++ ) {

      for( j = 0; j <= im_in.SizeY(); j++ ) {

         ux = BoxX[1][j+1];
         uy = BoxY[1][j+1];

	 if( Edge( BoxG, ux, uy, j+1 ) ) continue;

         t = (int)( (BoxG[1][j])*Scale1*scale );
         if( t > 256 ) t = 255;
         im_out.SetPixel( i, j, t );
      }

      if (i<im_in.SizeX()) {
         New_Temp_Line( n, BoxTemp1, BoxTemp2, im_in, m, n + i + 2 );
         Temp_Rot( n, BoxTemp1, BoxTemp2 );
	 New_X_Y_G_Lines( im_in.SizeX(), n, BoxTemp1, BoxTemp2, BoxX, BoxY,
                        BoxG, m1 );
         X_Y_G_Rot( BoxX, BoxY, BoxG );
      }
   }
}

void Canny( Image &im_in, Image &im_out, float disp, float scale )
{
   int n;
   float a, b, c, k1;
   RBox m1, m;
   PaBox BoxG, BoxX,BoxY;
   PaBox BoxTemp1,BoxTemp2;
   Image im_dir;

   im_out.Create( im_in.SizeX(), im_in.SizeY(), im_in.planes );

   n = 0;
   k1 = 3.0*6.283185*disp*disp;
   while( (gauss( n,disp ) > 0.005) && ( n < 10) ) {
      a = gauss( n,disp) ;
      b = gauss( n-0.5,disp );
      c = gauss( n+0.5,disp);
      m[n] = (a+b+c)/k1;
      m1[n] = c-b;
      n++;
   }

   n--;

   getAmem( &BoxG,3,im_in.SizeX()+3);
   getAmem( &BoxX,3,im_in.SizeX()+3);
   getAmem( &BoxY,3,im_in.SizeX()+3);

   getAmem( &BoxTemp1,(2*n+1),(im_in.SizeX()+3+2*n));
   getAmem( &BoxTemp2,(2*n+1),(im_in.SizeX()+3+2*n));

   Temp_Init(n,BoxTemp1,BoxTemp2,im_in,m);
   X_Y_G_Init(n,BoxX,BoxY,BoxG,BoxTemp1,BoxTemp2,m1,im_in,m);

   Main_Cycle(n,BoxX,BoxY,BoxG,BoxTemp1,BoxTemp2,m,m1,im_in,im_out,im_dir,scale);

   freeAmem( &BoxG,3,im_in.SizeX()+3);
   freeAmem( &BoxX,3,im_in.SizeX()+3);
   freeAmem( &BoxY,3,im_in.SizeX()+3);
   
   freeAmem( &BoxTemp1,(2*n+1),(im_in.SizeX()+3+2*n));
   freeAmem( &BoxTemp2,(2*n+1),(im_in.SizeX()+3+2*n));
}



/*
int main(void)
{
Image x;
int xx;

LoadPictureBMP("P-sue2.bmp",x);
printf("%d",x.planes);

SavePictureBMP("pokus1.bmp",x);

return(0);
}*/
